<script lang="ts">
  import CardBack from "./CardBack.svelte";
  import type { CardId } from "../server";
  import { send, receive } from "./util/crossfade";
  import { flip } from "svelte/animate";

  export let hand: CardId[];

  function getCardStyle(cardCount: number, idx: number): string {
    let rotationStep = 10;
    let startRotation = (1 - cardCount) * (rotationStep / 2);
    let rotation = startRotation + rotationStep * idx;
    return `
      --card-rotation: ${rotation.toFixed(2)}deg;
    `;
  }
</script>

{#each hand as cardId, idx (cardId)}
  <div class="card" style={getCardStyle(hand.length, idx)}>
    <div in:receive={{ key: cardId }} out:send={{ key: cardId }}>
      <CardBack />
    </div>
  </div>
{/each}

<style>
  .card {
    position: absolute;
    top: 0;
    left: 50%;
    transition: transform 0.2s;
    transform-origin: center 40em;
    transform: translate(-50%) rotate(var(--card-rotation));
  }
</style>
